## ros-lunar-ecto 0.6.12

=== CMakeLists.txt ===
#
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
cmake_minimum_required(VERSION 2.8)

project(ecto)

find_package(catkin REQUIRED)
find_package(Boost REQUIRED)
find_package(Threads REQUIRED)

set(Python_ADDITIONAL_VERSIONS 2.7)
find_package(PythonLibs REQUIRED)


catkin_package(CFG_EXTRAS ecto-extras.cmake
               DEPENDS Boost PYTHON Threads
               INCLUDE_DIRS include
               LIBRARIES ecto
)

# configure and install Python
catkin_python_setup()

set(${PROJECT_NAME}_GITHUB_URL https://github.com/plasmodic/ecto)

option(ECTO_TRACE_EXCEPTIONS "Trace ecto exceptions to stdout" OFF)

option(ECTO_STRESS_TEST "Stress testing of ecto" OFF)
if(ECTO_STRESS_TEST)
  message("ECTO_STRESS_TEST is ON")
endif()

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  option(ECTO_LOGGING "Ecto logging" ON)
else()
  option(ECTO_LOGGING "Ecto logging" OFF)
endif()

option(ECTO_WITH_INSTRUMENTATION "Instrument schedulers (for debugging)" OFF)

include(cmake/config.cmake)
include(cmake/boost.cmake)
include(cmake/version.cmake)
include(cmake/git.cmake)
include(cmake/ectoMacros.cmake)
include(cmake/doc.cmake)

git_status(ecto)

include_directories(include)
include_directories(src/lib)
include_directories(${CATKIN_DEVEL_PREFIX}/include)
include_directories(
  ${PYTHON_INCLUDE_PATH}
  ${Boost_INCLUDE_DIRS}
)

# deal with sources
set(ecto_LIBRARIES ecto)
add_subdirectory(src)
add_subdirectory(cmake)

set(ecto_SPHINX_DIR ${CMAKE_CURRENT_SOURCE_DIR}/python/ecto/sphinx)
ecto_sphinx(${CMAKE_CURRENT_SOURCE_DIR}/doc/kitchen)

option(BUILD_DOC "Build docs, this will build tests and samples as well." ON)
if(BUILD_DOC)
  set(CATKIN_ENABLE_TESTING ON CACHE BOOL "Tests must be built if docs are expected to build." FORCE)
  set(BUILD_SAMPLES ON CACHE BOOL "Samples must be built if docs are expected to build." FORCE)
  add_subdirectory(doc)
#  find_package(catkin-sphinx QUIET)
  if (catkin-sphinx_FOUND)
      catkin_sphinx(${CMAKE_CURRENT_SOURCE_DIR}/doc/source doc
              ${CMAKE_CURRENT_SOURCE_DIR}
              ${CMAKE_CURRENT_SOURCE_DIR}/samples
      )
  endif()
endif()

if(CATKIN_ENABLE_TESTING)
  add_subdirectory(test)
endif()

option(BUILD_SAMPLES "Build samples." ON)
if(BUILD_SAMPLES)
  add_subdirectory(samples)
endif()

# deal with doxygen and integration with sphinx
catkin_doxygen(ecto-doxygen "${CMAKE_CURRENT_SOURCE_DIR}/include;${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen")
add_custom_target(ecto-copy-doxygen-to-doc COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_BINARY_DIR}/ecto/api ${CMAKE_BINARY_DIR}/doc/html/ecto/api
                                           DEPENDS ecto-doxygen
)
add_dependencies(sphinx-doc ecto-copy-doxygen-to-doc)

=== cmake/CMakeLists.txt ===
# 
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
include(ectoInstall.cmake)

=== samples/CMakeLists.txt ===
# 
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
cmake_minimum_required(VERSION 2.8)
project(ecto_samples)

ectomodule(hello_ecto DESTINATION ecto
    hello_ecto.cpp
)

add_subdirectory(experimental)

=== src/CMakeLists.txt ===
# 
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
add_subdirectory(lib)
add_subdirectory(pybindings)

=== doc/talk/CMakeLists.txt ===
# 
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 

set(outdir ${CMAKE_BINARY_DIR}/doc/html/talk)
file(MAKE_DIRECTORY ${outdir})

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/talk.html
  COMMAND rsync -va ${CMAKE_CURRENT_SOURCE_DIR}/ui/ ${outdir}/ui/
  COMMAND cp ${ecto_SOURCE_DIR}/kitchen/doc/source/art/* ${outdir}
  COMMAND rst2s5 --theme-url=ui/ecto ${CMAKE_CURRENT_SOURCE_DIR}/talk.rst ${outdir}/talk.html
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
  
add_custom_target(talk-html DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/talk.html)

=== src/lib/CMakeLists.txt ===
#
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#this helps with visual studio projects.
file(GLOB ecto_HEADERS
  ${CMAKE_SOURCE_DIR}/include/ecto/*.hpp
  ${CMAKE_SOURCE_DIR}/include/ecto/*/*.hpp
  )
source_group("Headers" FILES ${ecto_HEADERS})

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_library(ecto SHARED
  abi.cpp
  cell.cpp
  edge.cpp
  tendril.cpp
  tendrils.cpp
  plasm.cpp
  plasm/impl.cpp
  util.cpp
  log.cpp
  except.cpp
  parameters.cpp
  profile.cpp
  python.cpp
  registry.cpp
  rethrow.cpp
  serialization.cpp
  scheduler.cpp
  graph/utilities.cpp
  strand.cpp
  test.cpp
  time.cpp
  ${ecto_HEADERS}
  )

target_link_libraries(ecto
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
  ${PYTHON_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
)

set_source_files_properties(log.cpp
  PROPERTIES
  COMPILE_FLAGS -DSOURCE_DIR=\\"${ecto_SOURCE_DIR}\\"
  )

if(UNIX)
  set_target_properties(ecto PROPERTIES
    COMPILE_FLAGS "${FASTIDIOUS_FLAGS}"
    VERSION ${ecto_VERSION}
    SOVERSION ${ECTO_SOVERSION}
    )
elseif(WIN32)
  set_target_properties(ecto PROPERTIES
    COMPILE_FLAGS "${FASTIDIOUS_FLAGS}"
    VERSION ${ecto_VERSION}
    SOVERSION ${ECTO_SOVERSION}
    OUTPUT_NAME ecto_cpp
    )
endif()

#install the main shared lib
install(TARGETS ecto
        DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        COMPONENT main
)

=== test/cells/CMakeLists.txt ===
#
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
ectomodule(ecto_test
  Accumulator.cpp
  Add.cpp
  BreakEveryN.cpp
  BpObjectToCellPtr.cpp
  CantCallMeFromTwoThreads.cpp
  ConfigureCalledOnce.cpp
  DontCallMeFromTwoThreads.cpp
  DoOverFor.cpp
  EmitAndAccept.cpp
  ExceptInConstructor.cpp
  FileIO.cpp
  Multiply.cpp
  Quitter.cpp
  QuitAfter.cpp
  Increment.cpp
  LatticeSleep.cpp
  Printer.cpp
  Ping.cpp
  Metrics.cpp
  Gather.cpp
  Generate.cpp
  RequiredInput.cpp
  RequiredParam.cpp
  RequiredIO.cpp
  Passthrough.cpp
  ParameterWatcher.cpp
  Sleep.cpp
  SleepPyObjectAbuser.cpp
  StartStopCounter.cpp
  Throttle.cpp
  ThrowAfter.cpp
  Uniform01.cpp
  throws_in_handler.cpp
  gil_exercise.cpp
  ecto_test.cpp
  DESTINATION  ecto
  INSTALL
)

=== test/compile/CMakeLists.txt ===
#
# Copyright (c) 2011, Willow Garage, Inc.
#  All rights reserved.
# 
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are met:
#      * Redistributions of source code must retain the above copyright
#        notice, this list of conditions and the following disclaimer.
#      * Redistributions in binary form must reproduce the above copyright
#        notice, this list of conditions and the following disclaimer in the
#        documentation and/or other materials provided with the distribution.
#      * Neither the name of the Willow Garage, Inc. nor the names of its
#        contributors may be used to endorse or promote products derived from
#        this software without specific prior written permission.
# 
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
#  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
#  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
#  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
#  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
#  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
#  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
#  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
#  POSSIBILITY OF SUCH DAMAGE.
# 
if(NOT ecto_SOURCE_DIR)
  #not doing a standalone test project, so don't do these types of tests.
  return()
endif()

option(ECTO_ENABLE_COMPILE_TESTS "Enable compile tests... only need to do this occasionally" 
  OFF)

if (ECTO_ENABLE_COMPILE_TESTS)
  macro(add_compile_fail_test FILENAME)
    add_library(compile_fail_${FILENAME} 
      STATIC
      EXCLUDE_FROM_ALL
      ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME}.cpp
      )

    set_target_properties(compile_fail_${FILENAME}
      PROPERTIES
      ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      )

    set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME}.cpp}
      PROPERTIES
      OBJECT_OUTPUTS THIS_DOES_NOT_EXIST_TO_PROVOKE_REBUILD_EVERY_TIME
      )
    
    add_test(NAME compile_fail_${FILENAME}
      COMMAND
      ${CMAKE_CURRENT_SOURCE_DIR}/fail.sh 
      ${CMAKE_MAKE_PROGRAM} compile_fail_${FILENAME})

  endmacro()


  macro(add_compile_pass_test FILENAME)
    add_library(compile_pass_${FILENAME} 
      STATIC
      EXCLUDE_FROM_ALL
      ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME}.cpp
      )

    set_target_properties(compile_pass_${FILENAME}
      PROPERTIES
      ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      )

    set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME}.cpp}
      PROPERTIES
      OBJECT_OUTPUTS THIS_DOES_NOT_EXIST_TO_PROVOKE_REBUILD_EVERY_TIME
      )
    
    add_test(NAME compile_pass_${FILENAME}
      COMMAND
      ${CMAKE_CURRENT_SOURCE_DIR}/pass.sh 
      ${CMAKE_MAKE_PROGRAM} compile_pass_${FILENAME})

  endmacro()

  add_compile_fail_test(redeclare)
  #TODO need to add expected error here?
  add_compile_pass_test(tendril_static_time_correct)
  add_compile_pass_test(tendril_static_time_correct2)
  add_compile_fail_test(tendril_static_time_nonspore)

  # expect "module_must_be_named_compile_fail_wrong_cell_module_namex"
  add_compile_fail_test(wrong_cell_module_name)
  # expect "module_must_be_named_whatshouldinameyou"
  add_compile_fail_test(wrong_module_name)

  #  For each public header file, create a test that compilation is
  #  successful if this header file is the only thing included.
  #
  file(GLOB_RECURSE ECTO_HEADERS 
    RELATIVE ${ecto_SOURCE_DIR}/include 
    ${ecto_SOURCE_DIR}/include/ecto/*.hpp)

  foreach(HEADER ${ECTO_HEADERS})

    string(REPLACE "/" "_" sanitized ${HEADER})
    string(REPLACE "." "_" sanitized ${sanitized})

    set(testname header_compiles_standalone_${sanitized})
    set(testsrc ${CMAKE_CURRENT_BINARY_DIR}/${testname}.cpp)

    configure_file(header_compile_test.cpp.in
      ${testsrc}
      @ONLY)

    add_library(${testname}
      STATIC
      EXCLUDE_FROM_ALL
      ${testsrc}
      )

    set_source_files_properties(${testsrc}
      PROPERTIES
      OBJECT_OUTPUTS THIS_DOES_NOT_EXIST_TO_PROVOKE_REBUILD_EVERY_TIME
      )
    
    set_target_properties(${testname}
      PROPERTIES
      ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      )

    add_test(NAME ${testname}
      COMMAND
      ${CMAKE_MAKE_PROGRAM} ${testname}
      )

  endforeach()


  file(GLOB_RECURSE ECTO_HEADERS_ABSPATH 
    ${ecto_SOURCE_DIR}/include/ecto/*.hpp
    ${ecto_SOURCE_DIR}/src/**/*.hpp)

  file(GLOB_RECURSE ECTO_SRC_ABSPATH 
    ${ecto_SOURCE_DIR}/src/*.cpp
    ${ecto_SOURCE_DIR}/test/cpp/*.cpp)

  file(GLOB_RECURSE ECTO_CMAKELISTS_ABSPATH 
    ${ecto_SOURCE_DIR}/CMakeLists.txt
    ${ecto_SOURCE_DIR}/*.cmake)

  add_test(NAME license_in_headers 
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/check_new_bsd_license.py ${ECTO_HEADERS_ABSPATH}
    )

  add_test(NAME license_in_src
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/check_new_bsd_license.py ${ECTO_SRC_ABSPATH}
    )

  add_test(NAME license_in_cmake
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/check_new_bsd_license.py ${ECTO_CMAKELISTS_ABSPATH}
    )

  file(GLOB ECTO_PY_ABSPATH
    ${ecto_SOURCE_DIR}/python/ecto/*.py
    ${ecto_SOURCE_DIR}/python/ecto/sphinx/*.py
    ${ecto_SOURCE_DIR}/test/scripts/*.py
    ${ecto_SOURCE_DIR}/samples/*.py
    )

  add_test(NAME license_in_py
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/check_new_bsd_license.py ${ECTO_PY_ABSPATH}
    )

endif()

=== test/cpp/CMakeLists.txt ===
#
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

if(NOT CATKIN_ENABLE_TESTING OR NOT TARGET ecto-test)
  message(STATUS "Disabling testing since gtest was not found.")
  return()
endif()

include_directories(${GTEST_INCLUDE_DIRS}
                    ${PYTHON_INCLUDE_PATH}
                    ${Boost_INCLUDE_DIRS}
)

catkin_add_gtest(ecto-test
  main.cpp
  tendril.cpp
  tendrils.cpp
  spore.cpp
  exceptions.cpp
  graph.cpp
  profile.cpp
  serialization.cpp
  strands.cpp
  scheduler.cpp
  clone.cpp
  static.cpp
  )

target_link_libraries(ecto-test
  ecto
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
  ${PYTHON_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
)

# This is actually used in the plasm loader Python test file
add_executable(plasm_loader
  plasm_loader.cpp
)

target_link_libraries(plasm_loader
  ecto
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
)

=== test/scripts/CMakeLists.txt ===
# 
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 

foreach(file
    throw_in_interpreter_thread

    test_addergraph
    test_async_bp_objects
    test_async_execution
    test_async_execution_harsh
    test_async_multiple_sched
    test_async
    test_blackbox
    test_break
    #test_bp_to_cell_ptr
    test_circular
    test_constant
    test_dealer
    test_doc
    test_dual_line_plasm
    test_entanglement
    test_exception
    test_exception_in_constructor
    test_fileIO
    test_handles
    test_If
    test_metrics
    test_module_qualification
    test_modules
    test_multiplasm_scheduler
    test_multiprocess
    test_nested_if
    test_no_ecto_import
    test_options
    test_parameter_callbacks
    test_passthrough
    test_ptime_bindings
    test_plasm
    test_process_return_values
    test_python_module
    test_random
    test_reconnect
    test_redirect
    test_required_io
    test_required_param
    # test_restart  # this needs thinking about... can't test nexecutions with a stateful cell
    test_shared_pass
    test_small_plasms
    test_start_stop_counter
    test_strands
    test_tendril
    test_tendril_type_reg
    test_tendrils
    test_tendrils_mux
    test_tendrils_serialization
    test_type_mismatch_errors
    test_wrong_param_type
    )
    add_test(ecto_${file}
        ${CATKIN_ENV}
        ${CMAKE_CURRENT_SOURCE_DIR}/${file}.py)

endforeach()

catkin_add_nosetests(test_lineplasm.py)
catkin_add_nosetests(save_load_plasm_file.py DEPENDENCIES plasm_loader)

=== doc/source/src/CMakeLists.txt ===
# 
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
ectomodule(ecto_examples DESTINATION ecto
  module.cpp
  Example01.cpp
  EnumAsInt.cpp
  EnumAsEnum.cpp
  )

=== src/pybindings/cells/CMakeLists.txt ===
#
# Copyright (c) 2011, Willow Garage, Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the Willow Garage, Inc. nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

ectomodule(cells DESTINATION ecto INSTALL
And.cpp
#BlackBox.cpp -- in ecto
Constant.cpp
Counter.cpp
Dealer.cpp
#ether.cpp -- in ecto
If.cpp
module.cpp
Passthrough.cpp
PassthroughN.cpp
PassthroughTendrils.cpp
tendril_mux.cpp
TrueEveryN.cpp
)

=== debian/changelog ===
ros-lunar-ecto (0.6.12-0stretch) stretch; urgency=high

  * fix tests on Kinetic
  * fix PySide dependency
  * add missing implementation for executing
    That fixes #233 <https://github.com/plasmodic/ecto/issues/233>
  * install the ecto library of test cells for users to utilise in their own tests.
  * checking for ecto-test target existence
  * Contributors: Daniel Stonier, Vincent Rabaud, edgarriba

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sat, 16 Apr 2016 22:00:00 -0000

ros-lunar-ecto (0.6.11-0stretch) stretch; urgency=high

  * minor doc syntax fixes
  * saner installation instructions from source.
  * add missing includes to make headers compile standalone
    - add cstddef to introduce std::size_t
    - add parameters.hpp to its implementation (works because of #pragma once)
  * fix bsd-license check script
    Not all Copyright is (1.) from 2011 and (2.) by Willow Garage
    autofix is undefined if ECTO_LICENSE_AUTOFIX is not exported.
  * Re-add thread library to linker list
    Regression caused by 8e354b5aa8281ea8117fc93adb290998b7810be7
  * docs about various entities that affect graph execution, also other minor cleanups.
    Removed the redundancies in the install docs (2x install instructions and 2x dependencies)
    and cleaned the place up a bit.
  * Provide test for ecto::BREAK return value.
  * implement ecto::BREAK behavior
    This patch makes ecto schedule the next iteration
    through the plasm with ecto::BREAK as discussed in
    https://github.com/plasmodic/ecto/issues/251
  * remove some old Willow Garage URLs
  * update doc's url
  * Contributors: Daniel Stonier, Michael Görner, Po-Jen Lai, Scott K Logan, Vincent Rabaud, v4hn

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 20 Sep 2015 22:00:00 -0000

ros-lunar-ecto (0.6.10-0stretch) stretch; urgency=high

  * update test for future fix
  * potentially fix compilation with Boost 1.58
    could be a fix for #275 <https://github.com/plasmodic/ecto/issues/275>
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Tue, 21 Jul 2015 22:00:00 -0000

ros-lunar-ecto (0.6.9-0stretch) stretch; urgency=high

  * re-add some Python tests
  * add missing PySide dependency
  * Contributors: Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 07 May 2015 22:00:00 -0000

ros-lunar-ecto (0.6.8-0stretch) stretch; urgency=high

  * threadable plasms update.
    This reintroduces some level of threading into ecto. It was initially
    removed in c2a24a51, but this left some legacy code
    wasn't working as expressed in the documentation. These updates
    allow parallel execution of plasms in separate threads. It doesn't
    quite reach the scope of the original plan for ecto (threading for
    free *inside* a plasms computation), but it does cover several useful
    scenarios.
  * convenience class for scheduling plasms across threads.
  * Reformatted cell processing result handler (trivial).
    For clarity, and points back to an issue created which discusses
    the BREAK/CONTINUE options.
  * Don't clobber the underlying c++ executions when aborting, be graceful.
    Previously used PyErr_SetInterrupt which would send a keyboard interrupt
    back to the controlling python script. However we don't want to abort
    in this way - it is preferable to let the execution gracefully bow out.
    More information and the actual code that does the bowing out is in
    pull request #250 <https://github.com/plasmodic/ecto/issues/250>.
  * activate gil release/call macros
  * Be free of the GIL!
    This lets ecto pipeline processing be free of its evil overlord, the [GIL](https://wiki.python.org/moin/GlobalInterpreterLock). That is, you can now schedule different plasms in different threads...e.g. some pseudocode:
    # ...construct some plasms
    image_scheduler = ecto.Scheduler(image_plasm)
    odometry_scheduler = ecto.Scheduler(odometry_plasm)
    image_thread = threading.Thread(name="image_thread", target=image_scheduler.execute)
    odometry_thread = threading.Thread(name="odometry_thread", target=odometry_scheduler.execute)
    image_thread.start()
    odometry_thread.start()
    image_thread.join()
    odometry_thread.join()
    ```
    Of course, inside a cell's process() call, you can always grab the GIL momentarily if you need to using the opposite macro...`ECTO_SCOPED_CALLPYTHON`.
  * Bugfix python lookup for internal class variables
    Probably went unnoticed for a long time since it wasn't used. Came across this (I think - was quite a while ago) while fleshing out pythonic cell construction with names and parameter args. Should have gone in at the same time as 39b9cad9.
  * fix doc
    fixes #239 <https://github.com/plasmodic/ecto/issues/239>
  * Don't clobber the underlying c++ executions when aborting, be graceful.
    Previously used PyErr_SetInterrupt which would send a keyboard interrupt
    back to the controlling python script. However we don't want to abort
    in this way - it is preferable to let the execution gracefully bow out.
    More information and the actual code that does the bowing out is in
    pull request #250 <https://github.com/plasmodic/ecto/issues/250>.
  * activate gil release/call macros
  * Bugfix python lookup for internal class variables
    Probably went unnoticed for a long time since it wasn't used. Came across this (I think - was quite a while ago) while fleshing out pythonic cell construction with names and parameter args. Should have gone in at the same time as 39b9cad9.
  * fix doc
    fixes #239 <https://github.com/plasmodic/ecto/issues/239>
  * tiers need a boost prefix with boost 1.57
  * Contributors: Daniel Stonier, Michael Görner, Vincent Rabaud

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 12 Mar 2015 23:00:00 -0000

ros-lunar-ecto (0.6.7-0stretch) stretch; urgency=high

  * Merge branch 'master' of github.com:plasmodic/ecto


=== debian/control ===
Source: ros-lunar-ecto
Section: misc
Priority: extra
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, python-dev, ros-lunar-catkin
Homepage: http://plasmodic.github.io/ecto/
Standards-Version: 3.9.2

Package: ros-lunar-ecto
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, python-dev, xdot
Description: Ecto is a hybrid C++/Python development framework for constructing and maintaining pipelines.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-ecto//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
